# @(#)default.mk        1.0 MetaWare Inc., Copyright 1990

# Use the SUFFIXES line that has the `~' characters if you use SCCS
SUFFIXES = .obj .c .h .cpp .c.obj .cpp.obj .h.obj .s .s.obj .S .ln .f .f.obj .F .l .l.obj .mod .sym .def .p .p.obj .r .y .sh .cps
.SUFFIXES: $(SUFFIXES)

OUTPUT_OPTION=			# local (SRC=.) source files
#OUTPUT_OPTION=-o $@		# non-local (SRC=..) source files

# C Definitions
CC=cc
CFLAGS=
CPPFLAGS=
LINT=lint
LINTFLAGS=
COMPILE.c=$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.c=$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH)
LINT.c=$(LINT) $(LINTFLAGS) $(CPPFLAGS) $(TARGET_ARCH)


# C++ Definitions
COMPILE.cpp=$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.cpp=$(CC) $(CFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH)

COMPILE.h=$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c

# YACC Definitions
YACC=yacc
YFLAGS=
YACC.y=$(YACC) $(YFLAGS)
.y:
	$(YACC.y) $<
	$(LINK.c) -o $@ y.tab.c $(LDLIBS)
	$(RM) y.tab.c
.y.c:
	$(YACC.y) $<
	mv y.tab.c $@
.y.ln:
	$(YACC.y) $<
	$(LINT.c) -o $@ -i y.tab.c
	$(RM) y.tab.c
.y.obj:
	$(YACC.y) $<
	$(COMPILE.c) -o $@ y.tab.c
	$(RM) y.tab.c

# LEX Definitions
LEX=lex
LFLAGS=
LEX.l=$(LEX) $(LFLAGS) -t
.l:
	$(RM) $*.c
	$(LEX.l) $< > $*.c
	$(LINK.c) -o $@ $*.c $(LDLIBS)
	$(RM) $*.c
.l.c :
	$(RM) $@
	$(LEX.l) $< > $@
.l.ln:
	$(RM) $*.c
	$(LEX.l) $< > $*.c
	$(LINT.c) -o $@ -i $*.c
	$(RM) $*.c
.l.obj:
	$(RM) $*.c
	$(LEX.l) $< > $*.c
	$(COMPILE.c) -o $@ $*.c
	$(RM) $*.c

# FORTRAN Definitions
FC=f77
FFLAGS=
COMPILE.f=$(FC) $(FFLAGS) $(TARGET_ARCH) -c
LINK.f=$(FC) $(FFLAGS) $(LDFLAGS) $(TARGET_ARCH)
COMPILE.F=$(FC) $(FFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.F=$(FC) $(FFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH)

# Ratfor Definitions
RFLAGS=
COMPILE.r=$(FC) $(FFLAGS) $(RFLAGS) $(TARGET_ARCH) -c
LINK.r=$(FC) $(FFLAGS) $(RFLAGS) $(LDFLAGS) $(TARGET_ARCH)

# Modula-2 Definitions
M2C=m2c
M2FLAGS=
MODFLAGS=
DEFFLAGS=
COMPILE.def=$(M2C) $(M2FLAGS) $(DEFFLAGS) $(TARGET_ARCH)
COMPILE.mod=$(M2C) $(M2FLAGS) $(MODFLAGS) $(TARGET_ARCH)

# Pascal Definitions
PC=pc
PFLAGS=
COMPILE.p=$(PC) $(PFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c
LINK.p=$(PC) $(PFLAGS) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH)

# Assembly Definitions
AS=as
ASFLAGS=
COMPILE.s=$(AS) $(ASFLAGS) $(TARGET_MACH)
COMPILE.S=$(CC) $(ASFLAGS) $(CPPFLAGS) $(TARGET_MACH) -c

# Conditional Macro Definitions (LINK, COMPILE, ARCHIVE, etc...)
.c	:= LINK = $(LINK.c) -o $@ $< $(LDLIBS)
.cpp.obj	:= COMPILE = $(COMPILE.cpp) $(OUTPUT_OPTION) $<
.c.obj	:= COMPILE = $(COMPILE.c) $(OUTPUT_OPTION) $<
.h.obj	:= COMPILE = $(COMPILE.h) $(OUTPUT_OPTION) $<
.c.a	:= ARCHIVE = $(COMPILE.c) -o $% $< ; $(AR) $(ARFLAGS) $@ $% ; $(RM) $%
.c.ln	:= LINT = $(LINT.c) $(OUTPUT_OPTION) -i $<
.f	:= LINK = $(LINK.f) -o $@ $< $(LDLIBS)
.f.obj	:= COMPILE = $(COMPILE.f) $(OUTPUT_OPTION) $<
.f.a	:= ARCHIVE = $(COMPILE.f) -o $% $< ; $(AR) $(ARFLAGS) $@ $% ; $(RM) $%
.F	:= LINK = $(LINK.F) -o $@ $< $(LDLIBS)
.F.obj	:= COMPILE = $(COMPILE.F) $(OUTPUT_OPTION) $<
.F.a	:= ARCHIVE = $(COMPILE.F) -o $% $< ; $(AR) $(ARFLAGS) $@ $% ; $(RM) $%
.r	:= LINK = $(LINK.r) -o $@ $< $(LDLIBS)
.r.obj	:= COMPILE = $(COMPILE.r) $(OUTPUT_OPTION) $<
.r.a	:= ARCHIVE = $(COMPILE.r) -o $% $< ; $(AR) $(ARFLAGS) $@ $% ; $(RM) $%
.def.sym:= COMPILE = $(COMPILE.def) -o $@ $<
.mod	:= LINK = $(COMPILE.mod) -o $@ -e $@ $<
.mod.obj  := COMPILE = $(COMPILE.mod) -o $@ $<
.mod.a  := ARCHIVE = $(COMPILE.mod) -o $% $< ; $(AR) $(ARFLAGS) $@ $% ; $(RM) $%
.p	:= LINK = $(LINK.p) -o $@ $< $(LDLIBS)
.p.obj	:= COMPILE = $(COMPILE.p) $(OUTPUT_OPTION) $<
.p.a	:= ARCHIVE = $(COMPILE.p) -o $% $< ; $(AR) $(ARFLAGS) $@ $% ; $(RM) $%
.s.obj	:= COMPILE = $(COMPILE.s) -o $@ $<
.s.a	:= ARCHIVE = $(COMPILE.s) -o $% $< ; $(AR) $(ARFLAGS) $@ $% ; $(RM) $%
.S.obj	:= COMPILE = $(COMPILE.S) -o $@ $<
.S.a	:= ARCHIVE = $(COMPILE.S) -o $% $< ; $(AR) $(ARFLAGS) $@ $% ; $(RM) $%
.sh	:= SCRIPT = cat $< >$@ ; chmod +x $@
.cps.h	:= NeWS = cps $*.cps

# Common Suffix Rules
.c .cpp .h .f .F .r .mod .p:				; $(LINK)
.c.obj .cpp.obj .h.obj .f.obj .F.obj .r.obj .def.sym .mod.obj .p.obj .s.obj .S.obj:	; $(COMPILE)
.c.a .f.a .F.a .r.a .mod.a .p.a .s.a .S.a:		; $(ARCHIVE)
.c.ln:							; $(LINT)
.sh:							; $(SCRIPT)
.cps.h:							; $(NeWS)

# Miscellaneous Rules
MAKE=make
LD=ld
LDFLAGS=
LDLIBS=
AR=ar
ARFLAGS=rv
GET=/usr/sccs/get
GFLAGS=
RM=rm -f

markfile.obj:	markfile
	echo "static char _sccsid[] = \"`grep @'(#)' markfile`\";" > markfile.c
	cc -c markfile.c
	$(RM) markfile.c

.SCCS_GET:
	?sccs get -s $@ -G$@

.SYM_LINK_TO:
	ln -s $< $@
