/***
*malloc.h - declarations and definitions for memory allocation functions
*
*   Copyright 1989  MetaWare, Incorporated - All Rights Reserved
*
*   Contains the function declarations for memory allocation functions;
*   also defines manifest constants and types used by the heap routines.
*
*
****************************************************************************/


/* data size definitions              */

#ifndef _SIZE_T_DEFINED
typedef unsigned int size_t;
#define _SIZE_T_DEFINED
#endif


/*  ANSI function prototypes */

extern void     * calloc(size_t, size_t);
extern void       free(void *);
extern void     * malloc(size_t);
extern void     * realloc(void *, size_t);

#ifdef __HIGHC__                   /* ansi extensions enabled        */


extern void     * alloca(size_t);
extern void       _ffree(void _far *);
extern void _far  *_fmalloc(size_t);

extern void _huge * _halloc(long, size_t);
extern void        _hfree(void _huge *);

extern void       _nfree(_near void *);
extern void _near *_nmalloc(size_t);


#endif /* noansi (__HIGHC__) */
